[edit.l 25may90]

(setq $a1)
(setq $rct)

<de undoSelFig (l foo)
   (make
      "Select Figure"
      (list
         *mark
         (mapcar *mark '((fig) (get fig 'corner))) )
      '((m c)
         (mapc *mark unMark)
         (mapc m mark)
         (mapc2 m c putCorner) )
      l
      foo >


<de doFigure (pt)
   (local (pt1 fig c)
      (setq pt1 (cons (grid (car pt)) (grid (cdr pt))))
      (setq fig (findFigure pt))
      (cond
         ((not fig)
            (if *lastFix
               (*lastFix pt1)
               (when *mark
                  (undoSelFig nil '(nil (mapc *mark unMark))) ) ) )
         ((isDoubleClick) (do doubleClick fig pt))
         ((setq c (onCorner (scale pt) fig))
            (chgCorner pt1 fig c) )
         ((onFrame pt fig)
            (if (onMark pt fig)
               (sizeFigure pt pt1 fig)
               (dragFigure pt1 *mark) )  )
         ((and
               (zerop (bitand shiftKey (ev-modifiers *event)))
               (eq 1 (length *mark))
               (eq fig (car *mark)) )
            (may content fig pt) )
         (t
            (if (zerop (bitand shiftKey (ev-modifiers *event)))
               (unless
                  (and
                     (eq fig (car *mark))
                     (eq 1 (length *mark)) )
                  (undoSelFig
                     (list fig)
                     '((fig)
                        (mapc *mark unMark)
                        (putCorner fig)
                        (mark fig) ) ) )
               (progn
                  (undoSelFig
                     (list fig)
                     '((fig)
                        (if (memq fig *mark)
                           (unMark fig)
                           (mark fig) >


<de bringFront ()
   (make
      "Bring to front"
      (list (get *app 'figures))
      '((x)
         (put *app 'figures x)
         (invalMarked) )
      (list (get *app 'figures))
      '((y)
         (mapc *mark '((fig) (setq y (delete fig y))))
         (put *app 'figures (append y *mark))
         (invalMarked) >

<de sendBack ()
   (make
      "Send to back"
      (list (get *app 'figures))
      '((x)
         (put *app 'figures x)
         (invalMarked) )
      (list (get *app 'figures))
      '((y)
         (mapc *mark '((fig) (setq y (delete fig y))))
         (put *app 'figures (append *mark y))
         (invalMarked) >

<de bringCloser ()
   (local (l)
      (make
        "bring closer"
         (list (get *app 'figures))
            '((x)
               (put *app 'figures x)
               (invalMarked) )
         nil
            '(()
               (setq l (copy (get *app 'figures)))
               (for (i (length l) 0 (sub1 i))
                  (when (memq (nth (sub1 i) l) *mark)
                     (swap i (sub1 i) l) ) )
               (put *app 'figures l)
               (invalMarked) >

<de sendFigBehind ()
   (local (l)
      (make
         "Send behind"
         (list (get *app 'figures))
         '((x)
            (put *app 'figures x)
            (invalMarked) )
         nil
         '(()
            (setq l (copy (get *app 'figures)))
            (for (i 0 (length l))
               (when (memq (nth i l) *mark)
                  (swap i (sub1 i) l) ) )
            (put *app 'figures l)
            (invalMarked) >

<de setABDE (i bz)
   (setq
      a (if (zerop i) (last bz) (nth (sub1 i) bz))
      b (nth i bz) )
   (if (eq (length bz) (inc i))
      (setq
         d (car bz)
         e (cadr bz) )
      (setq
         d (nth i bz)
         e (if (eq (length bz) (inc i)) (car bz) (nth i bz) >


<de getCorner (i bz)
   (local (a b d e)
      (setABDE i bz)
      (when (pointp a)
         (if (pointp b)
            b
            (when (pointp d)
               (ecke a (car b) d (if (pointp e) e (car e))) >

<de rndBez (bz r i)
   (local (a b d e pt)
      (setABDE i bz)
      (if (pointp (setq pt b))
         (unless (pointp d)
            (setq d (car d)) )
         (setq pt
            (intsec
               a
               (car b)
               d
               (setq d (if (pointp e) e (car e)) )
               t ) ) )
      (if (zerop i)
         (nconc
            (rndPt a pt d r)
            (if (pointp b)
               (cdr bz)
               (cddr bz) ) )
         (progn
            (setq bz (copy bz))
            (rplacd (nthcdr (sub1 i) bz)
               (nconc
                  (rndPt a pt d r)
                  (nthcdr
                     (if (pointp b) (add1 i) (add2 i))
                     bz ) ) )
            (sauberBez bz) >

<de corner (fig pt)
   (local (bz c d e n)
      (setq
         pt (pt-bez pt)
         bz (get fig 'bezier)
         d 01FFFFFFF
         n nil )
        (for (i 0 (length bz))
            (and
                (setq c (getCorner i bz))
                (lessp (setq e (distPt c pt)) d)
                (setq  d e  n i) ) )
        n >

<de rotSpot (h v)
   (do print 'spot
      (append
         (format (sub (PtToAngle $rct (cons h v)) $a1))
         " degrees" >

<de rotLine (pt1 pt2)
   (line2 pt1 pt2)
   (line2
      pt1
      (cons
         (sub (car pt1) (sub (car pt2) (car pt1)))
         (sub (cdr pt1) (sub (cdr pt2) (cdr pt1))) >

<de rotAngle (c)
   (local (pt)
      (when
         (setq pt
            (click
               c
               '((oldPt newPt) (rotLine oldPt newPt))
               nil
               t ) )
         (PtToAngle $rct pt) >

<de doMirror ()
   (local (rct x)
      (setq
         rct (sRect *mark)
         x (mul 100
            (scale1
               (div2 (add (left rct) (right rct))) ) ) )
      (make
         "Mirror"
         (list (mapcar *mark '((fig) (get fig 'bezier))))
         '((l)
            (mapc2 *mark l
               '((fig z)
                  (InvalFig fig)
                  (adjBez fig z) ) ) )
         (list x)
         '((x)
            (mapc *mark
               '((fig)
                  (Invalfig fig)
                  (adjBez fig (mirror (get fig 'bezier) x))) >

<de doRot ()
   (local (*spot c a a2)
      (mouse
         (zentrum
            (car (srect *mark))
            (cdr (srect *mark)) ) )
      (when
         (and
            (setq c (click))
            (setq $rct (sqRect c 1000))
            (setq $a1 (rotAngle c))
            (setq *spot rotSpot)
            (setq a2 (rotAngle c)) )
         (setq
            c (scale c)
            a (mul 100 (sub a2 $a1)) )
         (make
            "Rotate"
            (list (mapcar *mark '((fig) (get fig 'bezier))))
            '((l)
               (mapc2 *mark l
                  '((fig z)
                     (InvalFig fig)
                     (adjBez fig z)) ) )
            (list c a)
            '((c a)
               (mapc *mark
                  '((fig)
                     (invalFig fig)
                     (adjBez
                        fig
                        (mapcar (get fig 'bezier)
                           '((x)
                              (if (pointp x)
                                 (rotz x c a)
                                 (mapcar x
                                    '((y) (rotz y c a)) >

<de pasteFig (lst)
   (local (rct1 rct2 dh dv)
      (setq
         rct1 (if *mark (srect *mark) '((0.0)0.0))
         rct2 (srect lst)
         dh (sub (left rct1) (left rct2))
         dv (sub (top rct1) (top rct2)) )
      (mapc
         (setq lst (recalcFig lst))
         '((fig)
            ([figCoord] offsetFig fig dh dv) ) )
      lst >

<de recalcFig (lst)
   (mapcar lst
      '((fig)
         (local (fig1 ax ay bx by rct)
            (setq rct (get fig 'rgnBBox))
            (setq ax (scale (car rct)))
            (setq ay (scale (cdr rct)))
            (setq rct (OffsetRect rct 10 10))
            (setq bx (scale (car rct)))
            (setq by (scale (cdr rct)))
            (setq fig1 (new (class fig)))
            (setplist fig1 (copy (plist fig)))
            (setflags fig1 (flags fig))
            (offsetFig fig1 10 10)
            fig1 >

<de copyFig (lst)
   (mapcar lst
      '((fig)
         (local (fig1)
            (setq fig1 (new (class fig)))
            (setplist fig1 (copy (plist fig)))
            (setflags fig1 (flags fig))
            fig1 >

t [edit.l]
