[Met.l 18dec92]

(unless (boundp 'Env)
   (load "HD:Pico:picApp:*picApp.l") )

[++ Constants ++]
<setq
   SIZE-H 16
   SIZE-V 16
   GRID 20
>

[++ Idle application object ++]
(object idle)

<to setUp (App)
   (off Undo Redo)
   (setMenu IMBar) >

[++ Menu bars ++]
<de idleMBar ()
   (mkMBar
      ((#appleMark)
         ("" #(str "About PicApp..") T (aboutDialog)) )
      (#(str "File")
         ("/O" #(str "Open ..") [T (openCmd)])
         ("/N" #(str "New") T (newCmd))
         ("-")
         ("/Q" #(str "Quit") T (on Done)) )
      (#(str "Edit")
         ("/Z" #(str "Undo"))
         ("/R" #(str "Redo"))
         ("-")
         ("/X" #(str "Cut"))
         ("/C" #(str "Copy"))
         ("/V" #(str "Paste"))
         ("" #(str "Clear"))
         ("/D" #(str "Duplicate"))
         ("/A" #(str "Select All")) >

<de appMBar ()
   (mkMBar
      ((#appleMark)
         ("" #(str "About PicApp..") T (aboutDialog)) )
      (#(str "File")
         ("/O" #(str "Open ..") [T (openCmd)])
         ("/N" #(str "New") T (newCmd))
         ("-")
         ("/W" #(str "Close") T (do close App))
         ("/S" #(str "Save") [NIL (saveCmd)])
         ("" #(str "Save as ..")[NIL (doSave)])
         ("" #(str "Revert") [NIL (revertCmd)])
         ("-")
         ("/Q" #(str "Quit") T (on Done)) )
      (#(str "Edit")
         ("/Z" #(str "Undo"))
         ("/R" #(str "Redo"))
         ("-")
         ("/X" #(str "Cut"))
         ("/C" #(str "Copy"))
         ("/V" #(str "Paste"))
         ("" #(str "Clear"))
         ("/D" #(str "Duplicate"))
         ("/A" #(str "Select All")) >

[++ Functions ++]
<de init ()
   (reptn 6 (MoreMasters))
   (setq
      Event (alloc 16)
      IMBar (idleMBar)
      AppMBar (appMBar) )
   (do init 'spot)
   (do setUp (setq App 'idle))
   (run) >

<de cleanUp ()
>

<de aboutDialog ()
   (local (dlg itemHit)
      (setq dlg
         (dialog #dBoxProc NIL NIL (300.200) 240 150
            #btnCtrl (40.110) 50 20 #(str "Ok")
            #statText (70.30) 160 20 "Software Lab."
            #statText (60.60) 160 20 "Alexander Burger" ) )
      (boldItem dlg 1)
      (until (onep (ModalDialog doDlg itemHit)))
      (DisposDialog dlg) >

<de newCmd ()
   (local (obj)
      (with
         (setq obj
            (new 'metApp (60 . 40)
               #(add GRID (mul SIZE-H GRID))
               #(add GRID (mul SIZE-V GRID))
               "Met" ) )
         >

(object metApp picApp)

<to classify () 'metApp>

<to setUp (App)
   (setMenu AppMBar) >

<to update (App)
   (from docWin update App
      '(()
         (EraseRect (portRect Port))
         (PenNormal)
         (for (v 0 #SIZE-H)
            (for (h 0 #SIZE-V)
               (MoveTo
                  (add #GRID (mul h #GRID))
                  (add #GRID (mul v #GRID)))
               (Line 0 0) ) )
         >

T
